<?php
/*
 Package: Mihalism Multi Host Farsi
 Farsi by : Omid Samadbin in scriptcamp.ir
 Version: 4.0.0
 Copyright (c) 2007, 2008 Mihalism, Inc.
 License: http://www.gnu.org/licenses/gpl.txt GNU Public License
 ------------------------------------------------------------------------------
 contact me : Omid_Samadbin@yahoo.com ,  MihanTeam@gmail.com  ,  scriptcamp@gmail.com
 Tel me : 0935 522 99 46
 Other My Site : MihanTeam.Com  ,  Samadbin.Com  ,  GigScript.Info
 ------------------------------------------------------------------------------
 scriptcamp.ir Is Firest And Best Publisher Nulled And Free PHP, ASP, Ajax,... Script
*/

class mmhclass_mysql_driver
	{
		function mmhclass_mysql_driver()
		{
			global $mmhclass;
			if (extension_loaded("mysql") == false) {
				$mmhclass->templ->fatal_error("&#46;&#1705;&#1575;&#1585;&#32;&#1606;&#1605;&#1740;&#1705;&#1606;&#1583;&#32;&#80;&#72;&#80;&#44;&#77;&#89;&#83;&#81;&#76;&#32;&#1605;&#1578;&#1575;&#1587;&#1601;&#1575;&#1606;&#1607;&#32;&#1605;&#1608;&#1604;&#1578;&#1740;&#32;&#1607;&#1575;&#1587;&#1578;&#1585;&#32;&#1576;&#1583;&#1608;&#1606;");
			}
		}
		
		function connect($host = "localhost", $username, $password, $database, $new_link = NULL)
		{
			global $mmhclass;
			$connection_id = mysql_connect($host, $username, $password, true);
			
			if (is_resource($connection_id) == false) {
				$this->error();
			} else {
				if (mysql_select_db($database, $connection_id) == false) {
					$this->error();
				} else {
					if (is_resource($this->root_connection) == false) {
						$this->root_connection = $connection_id;
					} else {
						if ($mmhclass->funcs->is_null($new_link) == false) {
							if (is_array($this->alt_connections) == true) {
								$this->alt_connections = array();
							}
					
							$this->alt_connections[$new_link] = $connection_id;
						}
					}
				}
			}
			
			return $connection_id;
		}

		function close()
		{
			if (is_resource($this->root_connection) == true) {
				mysql_close($this->root_connection);
			}
			
			if (is_array($this->alt_connections) == true) {
				foreach ($this->alt_connections as $id => $connection) {
					mysql_close($this->alt_connections[$id]);
				}
			}
		}

		function query($query, $connection_id = NULL)
		{
			global $mmhclass;
			if (is_resource($this->root_connection) == false) {
				$this->connect($mmhclass->info->config['sql_host'], $mmhclass->info->config['sql_username'], $mmhclass->info->config['sql_password'], $mmhclass->info->config['sql_database']);
			}
			
			$query = str_replace("<# QUERY_LIMIT #>", ((($mmhclass->info->current_page * $mmhclass->info->config['max_results']) - $mmhclass->info->config['max_results']).", {$mmhclass->info->config['max_results']}"), $query);
			if ($mmhclass->info->config['sql_tbl_prefix'] != "mmh_" && $mmhclass->funcs->is_null($mmhclass->info->config['sql_tbl_prefix']) == false){
				$query = preg_replace("/mmh_(\S+?)([\s\.,]|$)/", ($mmhclass->info->config['sql_tbl_prefix']."\\1\\2"), $query);
			}
			
			if ($mmhclass->funcs->is_null($connection_id) == false) {
				if (is_resource($this->alt_connections[$connection_id]) == false) {
					$this->error($query, "{$connection_id}&#58;&#1582;&#1591;&#1575;&#1740;&#32;&#1606;&#1575;&#1588;&#1606;&#1575;&#1582;&#1578;&#1607;");
				}
			}
			
			$this->query_result = mysql_query($query, (($mmhclass->funcs->is_null($connection_id) == false) ? $this->alt_connections[$connection_id] : $this->root_connection));

			if ($this->query_result == false) {
				$this->error($query);
			} else {
				return $this->query_result;
			}
		}

		function total_rows($query_id)
		{
			return mysql_num_rows($query_id);
		}

		function fetch_array($query_id, $result_type = MYSQL_ASSOC)
		{
			return mysql_fetch_array($query_id, $result_type);
		}

		function error_number()
		{
			global $mmhclass;
			return (($mmhclass->funcs->is_null(mysql_error()) == false) ? mysql_errno() : "&#1582;&#1591;&#1575;&#1740;&#32;&#1606;&#1575;&#1588;&#1606;&#1575;&#1582;&#1578;&#1607;");
		}

		function error($query = "&#1607;&#1740;&#1670;&#32;&#1662;&#1585;&#1587;&#32;&#1608;&#32;&#1580;&#1608;&#1740;&#1740;&#32;&#1575;&#1580;&#1585;&#1575;&#32;&#1606;&#1588;&#1583;", $custom_error = NULL)
		{
			global $mmhclass;
			$error_message = (($mmhclass->funcs->is_null($custom_error) == false) ? $custom_error : mysql_error());
			$error_html = "\t\t\t<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">
			<html>
				<head>
					<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />
					<title>&#77;&#89;&#83;&#81;&#76;&#32;&#1582;&#1591;&#1575;&#1740;</title>
					<style type=\"text/css\">
					    	* { font-size: 100%; margin: 0; padding: 0; }
						body { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 75%; margin: 10px; background: #FFFFFF; color: #000000; }
						a:link, a:visited { text-decoration: none; color: #005fa9; background-color: transparent; }
						a:active, a:hover { text-decoration: underline; }						
						textarea { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; border: 1px dashed #000000; background: #FFFFFF; padding: 5px; background: #f4f4f4; }
					</style>
				</head>
				<body>
					<p>
						<b>MySQL Driver Error</b>
						<br /><br />
						&#1582;&#1591;&#1575;&#1740;&#1740;&#32;&#1585;&#1582;&#32;&#1583;&#1575;&#1583;&#1607;&#32;&#1575;&#1587;&#1578;&#32;&#77;&#121;&#83;&#81;&#76;&#32;&#1583;&#1585;
						&#1576;&#1601;&#1585;&#1587;&#1578;&#1740;&#1583;<a href=\"{$mmhclass->input->server_vars['server_admin']}\">{$mmhclass->input->server_vars['server_admin']}&#58;&#1604;&#1591;&#1601;&#1606;&#32;&#1605;&#1578;&#1606;&#32;&#1586;&#1740;&#1585;&#32;&#1585;&#1575;&#32;&#1601;&#1608;&#1585;&#1606;&#32;&#1705;&#1662;&#1740;&#32;&#1705;&#1585;&#1583;&#1607;&#32;&#1608;&#32;&#1576;&#1607;&#32;&#1570;&#1583;&#1585;&#1587;</a>.
						<br /><br />
						<textarea readonly=\"readonly\" rows=\"15\" cols=\"40\" style=\"width:500px;\">&#58;&#1586;&#1605;&#1575;&#1606;&#32;&#1585;&#1582;&#1583;&#1575;&#1583;&#32;".date("F j, Y, g:i:s a")."\n&#58;&#1570;&#1583;&#1585;&#1587;&#32;&#1570;&#1740;&#32;&#1662;&#1740;&#32;{$mmhclass->input->server_vars['remote_addr']}\r&#58;&#1582;&#1591;&#1575;&#32; {$error_message}\n&#58;&#1588;&#1605;&#1575;&#1585;&#1607;&#32;&#1582;&#1591;&#1575;&#32;".$this->error_number()."\n&#58;&#1662;&#1585;&#1587;&#32;&#1608;&#32;&#1580;&#1608;&#1740;&#32;&#1575;&#1580;&#1585;&#1575;&#32;&#1588;&#1583;&#1607;&#32;{$query}</textarea>
					</p>	
				</body>
			</html>";
			exit($error_html);
			return;
		}
	}

?>
